package net.roseindia.main;

import java.util.List;

import net.roseindia.bean.Student;
import net.roseindia.util.HibernateUtil;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.criterion.Projections;

public class AggegateFunction {

	@SuppressWarnings("unchecked")
	public static void main(String[] args) {

		Session session = HibernateUtil.getSessionFactory().openSession();

		Object object;

		try {
			// Max Projection
			Criteria criteria = session.createCriteria(Student.class);
			criteria.setProjection(Projections.max("rollNo"));
			List list = criteria.list();
			System.out.println("Max Roll No is = " + list.get(0));

			// Min Projection
			Criteria criteriaMin = session.createCriteria(Student.class);
			criteriaMin.setProjection(Projections.min("rollNo"));
			List minList = criteriaMin.list();
			System.out.println("Minimum Roll No is = " + minList.get(0));

			// rowCount Projection
			Criteria criteriaRowCount = session.createCriteria(Student.class);
			criteriaRowCount.setProjection(Projections.rowCount());
			List rowCountList = criteriaRowCount.list();
			System.out.println("Total No of Student is = " + rowCountList.get(0));

			
		} catch (HibernateException e) {

			e.printStackTrace();
		} finally {
			session.close();
		}

	}
}
